import { TableDefinition } from '@hexlabs/dynamo-ts';
import { Check, Monitor, Query } from '../generated/postgres-check-api/model';

type MonitorTable = {
  partitionKey: string;
  sortKey: string;
} & Monitor;

type CheckTable = {
  partitionKey: string;
  sortKey: string;
  expiry: number;
} & Check;

type QueryTable = {
  partitionKey: string;
  sortKey: string;
  expiry: number;
} & Query;

export const monitorTable = TableDefinition.ofType<MonitorTable>()
  .withPartitionKey('partitionKey')
  .withSortKey('sortKey');

export const checkTable = TableDefinition.ofType<CheckTable>()
  .withPartitionKey('partitionKey')
  .withSortKey('sortKey');

export const queryTable = TableDefinition.ofType<QueryTable>()
  .withPartitionKey('partitionKey')
  .withSortKey('sortKey');
